unit Prinpr;
{ This Unit shows how to use buttons and strings in the statusbar
  and how to use the function print_xywh(Canvas, ...

  I Use the wpFastPrint Method in this unit:
    1. Call   print_xywh(Canvas, ... , wpFastPrintInit)
    2. Then call  print_xywh(Canvas, ... , wpFastPrint)   so often as you like
    3. Call   print_xywh(Canvas, ... , wpFastPrintExit)
  You shoul NEVER forget to call wpFastPrintExit !
  The FastPrint Method is much faster wich large Text with lots of pages to print
  because initialisation is only done one time.

  If you have only short Text ore more time
  then you may call print_xywh(Canvas, ... , wpNormalPrint) and you dont have to worry.

  If you want to check if there is enoug space to print all lines you can call
    print_xywh(Canvas, ... , wpPrintCalc). You may do this after wpFastPrintInit, too.
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, WPRich, WPStatus, WPDefs;

type
  TPrintPreview = class(TForm)
    PaintBox1: TPaintBox;
    WPStatusBar1: TWPStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure WPStatusBar1Update(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure WPStatusBar1Selection(Sender: TObject; index: Integer;
      typ: TWPStatusItemCont; name: String; x, y, w: Integer;
      var Button: TMouseButton; var Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
    initialized : Boolean; { wpFastPrintInit called ? }
  public
    { Public-Deklarationen }
    last_line,first_line : Longint;
    WordProcessor : TWPRichText;
  end;

var
  PrintPreview: TPrintPreview;

implementation

{$R *.DFM}

procedure TPrintPreview.FormCreate(Sender: TObject);
begin
  WPStatusBar1.SetStringWidthIndex(0,75);
  WPStatusBar1.SetStringWidthIndex(1,75);
  WPStatusBar1.SetStringWidthIndex(1,75);
end;

procedure TPrintPreview.WPStatusBar1Update(Sender: TObject);
begin
  WPStatusBar1.SetStringIndex(0,IntToStr(first_line));
  WPStatusBar1.SetStringIndex(0,'');
  WPStatusBar1.SetStringIndex(0,'');
end;

procedure TPrintPreview.PaintBox1Paint(Sender: TObject);
begin
   if not initialized then                                     { I Use the FastPrintMethod ! }
   begin WordProcessor.Print_xywh(PaintBox1.Canvas,0,0,
              PaintBox1.Width,PaintBox1.Height, first_line,wpFastPrintInit);
         initialized := TRUE;
   end;
   last_line := WordProcessor.Print_xywh(PaintBox1.Canvas,0,0,
          PaintBox1.Width,PaintBox1.Height, first_line,wpFastPrint);
   { The last FALSE means that output shoud be done, not only calculation }
end;

procedure TPrintPreview.WPStatusBar1Selection(Sender: TObject;
  index: Integer; typ: TWPStatusItemCont; name: String; x, y, w: Integer;
  var Button: TMouseButton; var Shift: TShiftState);
begin
   if index=2 then Close { selected END }
   else if index=1 then   { selected NEXT }
   begin
          first_line := last_line;
          PaintBox1.invalidate;
          WPStatusBar1.SetStringIndex(0,IntToStr(first_line));
   end;
end;

procedure TPrintPreview.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   if initialized then                                     { Never forget to call Exit !  }
   begin WordProcessor.Print_xywh(PaintBox1.Canvas,0,0,
              PaintBox1.Width,PaintBox1.Height, first_line,wpFastPrintExit);
         initialized := TRUE;
   end;
end;

end.
